﻿using System.Collections.Generic;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Components;
using UserService.DatabaseLayer.DataModels;
using UserService.DatabaseLayer.Repository;

namespace UserService.Pages
{
    public class SecurityGroupsBase : ComponentBase
    {
        [Inject] private ISecurityGroupsRepository SecurityGroupsRepository { get; set; } = null!;
        [Inject] private IOrganizationUnitsRepository OrganizationUnitsRepository { get; set; } = null!;

        protected bool DialogIsOpen { get; set; }
        protected SecurityGroup? SecurityGroupToEdit { get; set; }

        protected IReadOnlyList<SecurityGroup>? Groups { get; set; }
        protected IReadOnlyList<OrganizationUnit>? OrganizationUnits { get; set; }

        protected override async Task OnInitializedAsync()
        {
            Groups = await SecurityGroupsRepository.GetAllAsync().ConfigureAwait(false);
            OrganizationUnits = await OrganizationUnitsRepository.GetAllAsync().ConfigureAwait(false);
        }

        protected void EditSecurityGroup(SecurityGroup securityGroup)
        {
            SecurityGroupToEdit = securityGroup;
            DialogIsOpen = true;
        }

        protected async Task OkClick()
        {
            if (!(SecurityGroupToEdit is null))
            {
                await SecurityGroupsRepository.UpdateAsync(SecurityGroupToEdit).ConfigureAwait(false);
            }

            DialogIsOpen = false;
        }

        protected async Task DeleteSecurityGroup(SecurityGroup securityGroup)
        {
            await SecurityGroupsRepository.DeleteAsync(securityGroup).ConfigureAwait(false);
        }
    }
}